/**
 * Written by Jason Heddings: http://mapit.mozdev.org/
 * License: http://creativecommons.org/licenses/by-nc-sa/2.0/
 * $Id: mapitAddress.js,v 1.3 2005/07/21 00:03:19 jheddings Exp $
 */
 
function MapItAddress(str) { this._init(str); }

////////////////////////////////////////////////////////////////////////////////

MapItAddress.prototype = {
  parsed:false,

  text:null,
  street:null,
  city:null,
  province:null,
  postal:null,
  country:null,

////////////////////////////////////////////////////////////////////////////////

  _init:function(str) {
    this._parse(str);
  },

////////////////////////////////////////////////////////////////////////////////

  _parse:function(str) {
		this.parsed = false;
		this.text = this._clean(str);
		gMapItService.log("parse address:\n" + this.text);

    if (str) {
      // try to match the address to an existing regular expression
      var regexps = gMapItService.settings.regexps;
      for (var idx = 0; idx < regexps.length; idx++) {
        var match = (new RegExp(regexps[idx])).exec(str, "m");
        if (match != null) {
          this.street = this._clean(match[1]);
          this.city = this._clean(match[2]);
          this.province = this._clean(match[3]);
          this.postal = this._clean(match[4]);
			    this.country = "US";
          this.parsed = true;
          break;
        }
      }
    }
  },

////////////////////////////////////////////////////////////////////////////////

  _clean:function(str) {
    return str.replace(/[^A-Za-z0-9 .,-]/g, " ");
  },

////////////////////////////////////////////////////////////////////////////////

  toString:function() {
    return this.street + "\n"
           + this.city + ", " + this.province + " " + this.postal + "\n"
           + this.country;
  },

////////////////////////////////////////////////////////////////////////////////
};