/**
 * Written by Jason Heddings: http://mapit.mozdev.org/
 * License: http://creativecommons.org/licenses/by-nc-sa/2.0/
 * $Id: mapitService.js,v 1.6 2005/07/21 17:59:30 jheddings Exp $
 */
 
var gMapItService = {
	mapcmd:null, // shared globally to represent the command being done
	address:null, // shared globally to represent the address being used
	prevAddress:null, // shared globally to represent the previous address used

  settings:null, // shared globally to access the settings
	mapper:null, // shared globally to access the mapper being used
	document:null, // shared globally to access the document being created

////////////////////////////////////////////////////////////////////////////////

  get version() { return "0.7"; },
  get id() { return "$Id: mapitService.js,v 1.6 2005/07/21 17:59:30 jheddings Exp $"; },

////////////////////////////////////////////////////////////////////////////////

  initialize:function() {
		var nWindows = countBrowserWindows();
		gMapItService.log("gMapItService initialize: " + nWindows + " windows");
		if (nWindows == 0) {
      this.mapper = new MapItMapper();
      this.settings = new MapItSettings();
		  this._loadMapperList();
		} else {
	    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
  	           .getService(Components.interfaces.nsIWindowMediator);

			var browsers = wm.getZOrderDOMWindowEnumerator("navigator:browser", true);
			while (browsers.hasMoreElements()) {
				var service = browsers.getNext().gMapItService;
				if (this.settings == null) { this.settings = service.settings; }
				if (this.mapper == null)   { this.mapper = service.mapper;     }
			}
		}
	},

	////////////////////////////////////////////////////////////////////////////////

	_loadMapperList:function() {
		// even though it seems like calling this.settings would find the object
		// but, we still must use the this._settings object for this method
		this.log("load maplist: " + gMapItService.settings.mapList);

		// load the mappers list asynchronously
		var listReqStart = (new Date()).getTime();
		var listRequest = new XMLHttpRequest();
		listRequest.open("GET", gMapItService.settings.mapList, true);
		listRequest.onreadystatechange = function (aEvt) {
			// we're not handling any other cases here...  should we?
			// since this is the async method, use the global service to access variables

			// the request completed, let's check it out
			if (listRequest.readyState == 4) {
				var listReqStop = (new Date()).getTime();
				if (listRequest.responseXML != null) {
					gMapItService.settings.mappers = mapitParseMappers(listRequest.responseXML);
					gMapItService.mapper.reload();
				}

        var secs = (listReqStop - listReqStart) / 1000;
				gMapItService.log("mapper list received: " + listRequest.responseText.length
													+ " bytes [" + secs + " secs]\n"
													+ gMapItService.settings.mappers["$id$"]);
			}
		};
		listRequest.send(null);
	},

////////////////////////////////////////////////////////////////////////////////

  //log:function(str) { this._console.logStringMessage("MAPIT: " + str); },
  log:function(str) { },

////////////////////////////////////////////////////////////////////////////////

  get _console() {
		return Components.classes["@mozilla.org/consoleservice;1"]
           .getService(Components.interfaces.nsIConsoleService);
	}

////////////////////////////////////////////////////////////////////////////////
};