/**
 * Written by Jason Heddings: http://mapit.mozdev.org/
 * License: http://creativecommons.org/licenses/by-nc-sa/2.0/
 * $Id: mapitCore.js,v 1.21 2005/07/21 00:03:18 jheddings Exp $
 */

// the CVS id for this file
var gMapItCoreId = "$Id: mapitCore.js,v 1.21 2005/07/21 00:03:18 jheddings Exp $";

////////////////////////////////////////////////////////////////////////////////
// Attempt to read address from selected text.

// mapcmd options:
// map  - just show the map
// to   - show directions to location from saved address
// from - show directions from location to saved address
function mapitSelectedText(mapcmd) {
  gMapItService.mapcmd = mapcmd;
  gMapItService.address = mapitReadSelectedAddress();

  if (gMapItService.address == null) {
    mapitAddressPrompt();
  } else {
    mapit();
	}
}

////////////////////////////////////////////////////////////////////////////////
// Map a specific address.

function mapit() {
  var form = null;
	var mapper = gMapItService.mapper;
	var mapcmd = gMapItService.mapcmd;
	var address = gMapItService.address;
  var settings = gMapItService.settings;
  var dfault = mapitLoadDefaultAddress();

  // make sure it is okay to proceed
  if ((address == null) || ((! mapper.freeText) && (! address.parsed))) {
		gMapItService.log("cannot map address\n" + address.text);
		alert("invalid address");
    return;
  }

  // copy the address to the clipboard
	if (settings.clipboard == "on") {
		setClipboardText(address.text);
	}

  // load the correct form
	switch (mapcmd) {
		case "map":  form = mapper.getShowMapForm(address); break;
		case "to":   form = mapper.getDirectionsForm(address, dfault); break;
		case "from": form = mapper.getDirectionsForm(dfault, address); break;
	}

	// submit the form
  if (form != null) {
    mapitSubmit(form);
		gMapItService.prevAddress = address;
  } else {
		alert("ERROR (0x44ba): Could not load form");
	}
}

////////////////////////////////////////////////////////////////////////////////
// Load the correct default address for getting directions based on settings.

function mapitLoadDefaultAddress() {
  var settings = gMapItService.settings;

	// set up the default second address (if we should)
  var dfault = null;
	if (settings.directions == "home") {
		// use the home address
		dfault = new MapItAddress(settings.homeAddress);
	} else if (settings.directions == "prev") {
		// load the previous address
		dfault = gMapItService.prevAddress;
	}
	
	// if still null, we need to prompt for an address
	if (dfault == null) {
	}
	
	return dfault;
}

////////////////////////////////////////////////////////////////////////////////
// Parse the mappers from a "mappers" XML document.

function mapitParseMappers(doc) {
  var mappers = new Array();
	var docElement = doc.documentElement;
  // push each of the mappers to our array
  if (docElement.tagName == "mappers") {
		mappers["$id$"] = docElement.getAttribute("id");
    var children = docElement.childNodes;
    for (var idx = 0; idx < children.length; idx++) {
      var node = children.item(idx);
      if (node.tagName == "mapper") {
				mappers[node.getAttribute("name")] = node.getAttribute("url");
      }
    }
  }
  return mappers;
}

////////////////////////////////////////////////////////////////////////////////
// Display the MapIt! address dialog.

function mapitAddressPrompt() {
	window.open("chrome://mapit/content/mapitDialog.xul", "_blank", "chrome,resizable");
}

////////////////////////////////////////////////////////////////////////////////
// Display the MapIt! options dialog.

function mapitConfig() {
  window.open("chrome://mapit/content/mapitOptions.xul", "_blank", "chrome,resizable");
}