/**
 * Written by Jason Heddings: http://mapit.mozdev.org/
 * License: http://creativecommons.org/licenses/by-nc-sa/2.0/
 * $Id: mapitOverlay.js,v 1.3 2005/07/19 22:05:43 jheddings Exp $
 */

////////////////////////////////////////////////////////////////////////////////
function mapitOnLoad() {
	gMapItService.log("countBrowserWindows(): " + countBrowserWindows());

	if (countBrowserWindows() == 0) {
		// even though it seems like calling gMapItService.settings would find
		// this object since we are creating it here, we still must use the
		// gMapItService._settings object for this method --jah
		gMapItService._settings = new MapItSettings();
    gMapItService.log("maplist: " + gMapItService._settings.mapList);

		// load the mappers list asynchronously
		var listRequest = new XMLHttpRequest();
		listRequest.open("GET", gMapItService._settings.mapList, true);
		listRequest.onreadystatechange = function (aEvt) {
			// we're not handling any other cases here...  should we?

			// the request completed, let's check it out
			if (listRequest.readyState == 4) {
				gMapItService.log("mapper list received: " + listRequest.responseText.length + "b");
				if (listRequest.responseXML != null) {
					gMapItService.settings.mappers = mapitParseMappers(listRequest.responseXML);
				}
			}
		};
		listRequest.send(null);
	}
}

////////////////////////////////////////////////////////////////////////////////
function showMapItPopup() {
	var settings = gMapItService.settings;
	if (settings != null) {
		var contextMenu = (settings.contextMenu == "on");
    gMapItService.log("showMapItPopup(): contextMenu:" + contextMenu);
		document.getElementById("mapit-popup-sep").hidden = (! contextMenu);
		document.getElementById("mapit-context-menu").hidden = (! contextMenu);
		document.getElementById("mapit-single-item").hidden = (contextMenu);
	}
}

////////////////////////////////////////////////////////////////////////////////
function hideMapItPopup() {
  gMapItService.log("hideMapItPopup()");
}

////////////////////////////////////////////////////////////////////////////////
window.addEventListener("load", mapitOnLoad, false);